/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package es.uca.takuan.netbeans.wizard;

import es.uca.takuan.client.Bpel;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.tree.TreePath;
import org.openide.util.NbBundle;

/**
 * @author Alejandro
 */
public final class BpelVisualPanel3 extends JPanel {

    private boolean defaultOld = false;
    private Bpel bpel;

    /** Creates new form BpelVisualPanel3 */
    public BpelVisualPanel3() {
        initComponents();
    }

    @Override
    public String getName() {
        return NbBundle.getMessage(BpelVisualPanel3.class, "WIZARD_POINTS_TITLE");
    }

    /** Update the caption of the points list
     */
    public void updatePointsLabel() {
        defaultOld = checkDefault.isSelected();
        if(checkDefault.isSelected())
            lblPoints.setText(org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "WIZARD_POINTS_NO_POINTS"));
        else
            lblPoints.setText(org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "WIZARD_POINTS_POINTS"));
    }

    /** Set the BPEL where we want to update the list
     * @param b The BPEL object
     */
    public void setBpel(Bpel b) {
        bpel = b;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblDescription = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        treeBpel = new javax.swing.JTree();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstPoints = new javax.swing.JList();
        lblTree = new javax.swing.JLabel();
        lblPoints = new javax.swing.JLabel();
        cmdAdd = new javax.swing.JButton();
        cmdRemove = new javax.swing.JButton();
        checkDefault = new javax.swing.JCheckBox();

        lblDescription.setFont(new java.awt.Font("Dialog", 0, 12));
        org.openide.awt.Mnemonics.setLocalizedText(lblDescription, org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "WIZARD_POINTS_DESCRIPTION")); // NOI18N
        lblDescription.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jScrollPane1.setViewportView(treeBpel);

        lstPoints.setFont(new java.awt.Font("Dialog", 0, 12));
        lstPoints.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "process/sequence/while[0]", "process/sequence/while[0]/if[1]" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane2.setViewportView(lstPoints);

        lblTree.setFont(new java.awt.Font("Dialog", 0, 12));
        org.openide.awt.Mnemonics.setLocalizedText(lblTree, org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "WIZARD_POINTS_TREE")); // NOI18N

        lblPoints.setFont(new java.awt.Font("Dialog", 0, 12));
        org.openide.awt.Mnemonics.setLocalizedText(lblPoints, org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "WIZARD_POINTS_POINTS")); // NOI18N

        cmdAdd.setIcon(new javax.swing.ImageIcon(getClass().getResource("/es/uca/takuan/netbeans/add.png"))); // NOI18N
        cmdAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addActionPerformed(evt);
            }
        });

        cmdRemove.setIcon(new javax.swing.ImageIcon(getClass().getResource("/es/uca/takuan/netbeans/remove.png"))); // NOI18N
        cmdRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeActionPerformed(evt);
            }
        });

        checkDefault.setFont(new java.awt.Font("Dialog", 0, 12));
        org.openide.awt.Mnemonics.setLocalizedText(checkDefault, org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "WIZARD_POINTS_DEFAULT")); // NOI18N
        checkDefault.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkDefaultActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lblDescription, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 437, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(checkDefault, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 302, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 224, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(cmdRemove, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(cmdAdd, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(lblTree))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(lblPoints, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
                            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(lblDescription, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 43, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(checkDefault)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lblTree)
                    .add(lblPoints))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(89, 89, 89)
                        .add(cmdAdd)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(cmdRemove)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 81, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 228, Short.MAX_VALUE)
                            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 228, Short.MAX_VALUE))))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    /** Add a point to the instrumentation list
     * @param evt
     */
    private void addActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addActionPerformed
        TreePath[] selection = treeBpel.getSelectionPaths();
        int i;
        DefaultListModel model = (DefaultListModel) lstPoints.getModel();
        String aux;
        
        // Iterate
        for(i = 0; i < selection.length; i++) {
            aux = selection[i].toString();
            // Remove []
            aux = aux.substring(1, aux.length() - 1);
            // Replace ','
            aux = aux.replaceAll(", ", "/");
            // Add root
            aux = "/" + aux;
            // Add
            model.addElement(aux);
        }
    }//GEN-LAST:event_addActionPerformed

    /** Remove a point from the intrumentation list
     * @param evt
     */
    private void removeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeActionPerformed
        int [] selection = lstPoints.getSelectedIndices();
        int i;
        DefaultListModel model = (DefaultListModel) lstPoints.getModel();
        
        // We remove from end to beggining
        for(i = selection.length - 1; i >= 0; i--)
            model.removeElementAt(selection[i]);
    }//GEN-LAST:event_removeActionPerformed

    private void checkDefaultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkDefaultActionPerformed
        // If the state has changed, ask to reload
        if(defaultOld != checkDefault.isSelected()) {
            if(JOptionPane.showConfirmDialog(this,
                    org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "RELOAD_POINTS"),
                    org.openide.util.NbBundle.getMessage(BpelVisualPanel3.class, "RELOAD_TITLE"),
                    JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                DefaultListModel model = (DefaultListModel) lstPoints.getModel();
                List<String> points;

                model.clear();
                points = bpel.getInstrumentalized(!checkDefault.isSelected());

                int i;
                for(i = 0; i < points.size(); i++)
                    model.addElement(points.get(i));
            }
        }
        // Update
        updatePointsLabel();
    }//GEN-LAST:event_checkDefaultActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JCheckBox checkDefault;
    private javax.swing.JButton cmdAdd;
    private javax.swing.JButton cmdRemove;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblDescription;
    public javax.swing.JLabel lblPoints;
    private javax.swing.JLabel lblTree;
    public javax.swing.JList lstPoints;
    public javax.swing.JTree treeBpel;
    // End of variables declaration//GEN-END:variables
}

